/*
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 1, or (at your option)
** any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * Author : Alexandre Parenteau <aubonbeurre@geocities.com> --- December 1997
 */

/*
 * AppGlue.h --- glue code to access CVS shared library
 */

#ifndef APPGLUE_H
#define APPGLUE_H

#include <stdio.h>
#include <iostream>
#include <string>

class CCvsConsole
{
public:
	virtual long Out(char *txt, long len) = 0L;
	virtual long Err(char *txt, long len) = 0L;
	virtual long In(char *txt, long len) = 0L;
	virtual bool YesNo() = 0L;
	virtual void Flush() = 0L;
	virtual bool ShouldStop() = 0L;
	virtual char* GetPassword() = 0L;
};

	// return the exit() error code.
	// optionnaly overides the default console.

class CvsArgs;
int launchCVS(bool wincvslib, const char *path, int argc, char * const *argv,
	CCvsConsole * console = 0L);

	// make a stream of the cvs output


	void WaitForCvs(void);

#endif /* APPGLUE_H */
