#if !defined(AFX_DIFFDIALOG_H__99BCCDE6_9486_466E_874C_FA15E8AB341F__INCLUDED_)
#define AFX_DIFFDIALOG_H__99BCCDE6_9486_466E_874C_FA15E8AB341F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DiffDialog.h : header file
//

class Eskimo;
#include "FilePath.h"
#include "UserSettings.h"
#include "Revision.h"

/////////////////////////////////////////////////////////////////////////////
// DiffDialog dialog

class DiffDialog : public CDialog
{
// Construction
public:
	DiffDialog(Eskimo* eskimo_, FilePath filePath_, CWnd* pParent = NULL);   // standard constructor

	BOOL OnInitDialog();

	// Dialog Data
	//{{AFX_DATA(DiffDialog)
	enum { IDD = IDD_DIFF };
	CStatic	m_ExeLabel;
	CStatic	m_AncestorLabel;
	CComboBox	m_Ancestors;
	CButton	m_ExeBrowse;
	CEdit	m_ExeBox;
	CComboBox	m_Revisions;
	CString	m_FilePath;
	int		m_Revision;
	CString	m_Exe;
	int		m_Type;
	int		m_Ancestor;
	//}}AFX_DATA

	bool WasCancelled();
	Revision GetRevision();
	Revision GetAncestor();
	string GetExe();
	UserSettings::DiffType GetDiffType();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(DiffDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	

// Implementation
protected:
	void SetTypeSensitivity();
	// Generated message map functions
	//{{AFX_MSG(DiffDialog)
	virtual void OnOK();
	afx_msg void OnBrowse();
	afx_msg void OnEditchangeType();
	afx_msg void OnSelchangeType();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	Eskimo* eskimo;
	bool ok;
	int revisionIndex;
	int ancestorIndex;
	RevisionVector revisions;
	UserSettings::DiffType diffType;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DIFFDIALOG_H__99BCCDE6_9486_466E_874C_FA15E8AB341F__INCLUDED_)
