#include "stdafx.h"
#include "FileList.h"
#include <string.h>

FileList::FileList(ostream& warning_) : lists(0), warning(warning_)
{
}

void FileList::SetReadOnly()
{
	for (int i=0; i<NumberOfLists(); i++)
	{
		for (int j=0; j<lists[i].size(); j++)
		{
			FilePath path=lists[i][j];
			if (!path.GetBackupFilePath().Exists())
			{
				if (! path.SetReadOnly())
				{
					warning << "Error with " << path << endl;
				}
			}
		}
	}
}

void FileList::SetWriteable()
{
	for (int i=0; i<NumberOfLists(); i++)
	{
		for (int j=0; j<lists[i].size(); j++)
		{
			if (! lists[i][j].SetWriteable())
			{
				warning << "Error with " << lists[i][j] << endl;
			}
		}
	}
}


const FilePathVector& FileList::GetList(int index) const
{
	return lists[index];
}

int FileList::NumberOfLists() const
{
	return numberOfLists;
}

FileList::~FileList()
{
	delete [] lists;
}