#ifndef _FilesMonitor_h
#define _FilesMonitor_h


#include <string>
#include <ostream>
#include <vector>
#include <set>
using namespace std;
#include "FilePath.h"
#include <map>
#include "Eskimo.h"
#include "CriticalSection.h"

#pragma warning (disable:4786)

typedef std::set<FilePath> FilePathSet;
typedef map<FilePath, FilePathSet*> FilesMap;
typedef map<FilePath, Eskimo::FileStatus> StatusMap;

class FilesMonitor
{
public:
	FilesMonitor();
	void Monitor(FilePath filePath, Eskimo::FileStatus status);
	Eskimo::FileChanged NextFileChanged();
	int FilesChanged();
	void SetEnabled(bool enabled);

	~FilesMonitor();
private:
	friend class DirectoriesMonitor;
	typedef vector<DirectoriesMonitor*> DirectoriesMonitors;
	void ProcessDirectory(FilePath directory);
	void ProcessFiles(const FilePathSet& files);
	FilesMap filesMap;
	StatusMap statusMap;
	FilePathSet cvsDirectories;
	DirectoriesMonitors directoriesMonitors;
	FilePathSet eventSet;
	CriticalSection filesLock;
	CriticalSection lock;
};


#endif // _FilesMonitor_h