#include "stdafx.h"
#include "IglooDialogs.h"
#include "CreateModule.h"
#include "LoginDialog.h"
#include "RunningDialog.h"
#include "SettingsDialog.h"
#include "DiffDialog.h"
#include "Eskimo.h"
#include "AraxisMerge.h"

class RunningThread : public CWinThread
{
public:
	RunningThread()
	{
	}
    RunningThread(HANDLE handle_,HWND parent_, DWORD parentThread_) : 
	handle(handle_), parent(parent_), parentThread(parentThread_), pauseCount(false)
	{
	}
	virtual BOOL InitInstance( )
	{
        AFX_MANAGE_STATE(AfxGetStaticModuleState( ));
//		::AttachThreadInput(::GetCurrentThreadId(), parentThread, true);
        dialog= new RunningDialog(handle, CWnd::FromHandle(0/*parent*/));
        dialog->DoModal();
        delete dialog;
//		::AttachThreadInput(::GetCurrentThreadId(), parentThread, false);
	    SetEvent(handle);
//		*result=MessageBox(0, question.c_str(), "CVS question", MB_YESNO | MB_ICONQUESTION | MB_TASKMODAL);
		return 0;
	}
    virtual void Stop()
    {
     //   dialog->EndDialog(0);
       /* typedef struct tagCOPYDATASTRUCT { 
    ULONG_PTR dwData; 
    DWORD     cbData; 
    PVOID     lpData; 
} COPYDATASTRUCT, */
        /*COPYDATASTRUCT data;
        ULONG dwData=0;
        data.dwData=0;
        data.cbData=0;
        dialog->SendMessage(WM_COPYDATA,  0,  (LPARAM)&data);*/
		dialog->messageBox=false;
        dialog->PostMessage(WM_COMMAND, 0x0310, 0);

    }
	int MessageBox(string message, string caption, int flags)
	{
		dialog->message=message;
		dialog->caption=caption;
		dialog->flags=flags;
		dialog->messageBox=true;
        dialog->PostMessage(WM_COMMAND, 0x0310, 0);
	    WaitForSingleObject(handle, INFINITE);
        ResetEvent(handle);
		dialog->messageBox=false;
		return dialog->returnValue;
	}


	virtual int ExitInstance()
	{
		return 1;
	}

	bool ShouldStop()
	{
		return dialog->ShouldStop();
	}

	void Pause()
	{
//		dialog->ShowWindow(SW_HIDE);
		pauseCount++;
	}

	void Unpause()
	{
		pauseCount--;
		if (pauseCount<=0)
		{
//			dialog->ShowWindow(SW_SHOW);
		}
	}

	HANDLE handle;
    HWND parent;
	int pauseCount;
    RunningDialog* dialog;
	DWORD parentThread;
	DECLARE_DYNCREATE(RunningThread)
};

class PauseRunning
{
public:
	PauseRunning(RunningThread* running_) : running(running_)
	{
		if (running) running->Pause();
	}
	~PauseRunning()
	{
		if (running) running->Unpause();
	}
private:
	RunningThread* running;
};

#define PAUSE PauseRunning pauseRunning(runningThread);

IMPLEMENT_DYNCREATE(RunningThread,CWinThread)

IglooDialogs::IglooDialogs() : parentWindow(0), eskimo(0), runningThread(0), autoNo(false)
{
}

CWnd* IglooDialogs::BaseWindow()
{
	if (runningThread)
	{
		return runningThread->dialog;
	}
	return CWnd::FromHandle(parentWindow);
}


void IglooDialogs::NotifyIDE()
{
	HWND wnd= ::GetForegroundWindow();
	SetForegroundWindow (wnd);
//	::SetActiveWindow(0);
//	::SetActiveWindow(wnd);
//		NMHDR n;
//		PostMessage(wnd, WM_NOTIFY, NULL, (LPARAM)&n);
//		PostMessage(wnd, WM_COMMAND, NULL, NULL);
//		PostMessage(wnd, WM_ENTERIDLE, NULL, NULL);
//		::EnableWindow(wnd, false);
//		::EnableWindow(wnd, true);
		//PostMessage(wnd, WM_ENABLE, 1, NULL);
		///MSGF_MENU
}


void IglooDialogs::SetEskimo(Eskimo* eskimo_)
{
	eskimo=eskimo_;
}

void IglooDialogs::SetParentWindow(HWND window)
{
	parentWindow=window;
}

void IglooDialogs::EnableParent(bool enable)
{
	if (parentWindow)
	{
		::EnableWindow(parentWindow, enable);
		if (enable) ::SetActiveWindow(parentWindow);

	}
}

bool IglooDialogs::IsParentEnabled()
{
	if (parentWindow)
	{
		::IsWindowEnabled(parentWindow);
	}
	return false;
}

void IglooDialogs::SetAutoNo(bool value)
{
	autoNo=value;
}

class YesNoThread : public CWinThread
{
public:
	YesNoThread() : result(0)
	{
	}
	YesNoThread(HANDLE handle_, int* result_, string question_) : result(result_), question(question_)
	{
		handle=handle_;
	}
	virtual BOOL InitInstance( )
	{
		*result=MessageBox(0, question.c_str(), "CVS question", MB_YESNO | MB_ICONQUESTION | MB_TASKMODAL);
		return 0;
	}
	virtual int ExitInstance()
	{
		SetEvent(handle);
		return 1;
	}
	HANDLE handle;
	int* result;
	string question;
	DECLARE_DYNCREATE(YesNoThread)
};

IMPLEMENT_DYNCREATE(YesNoThread,CWinThread)

/*
	The question must be asked in a separate thread otherwise
	it will CodeWrite will process an event and create a file lock
	on the file that we are dealing with.
*/
bool IglooDialogs::YesNo(string question)
{
	if (autoNo) return false;
	PAUSE;
	HANDLE handle = CreateEvent( 
        NULL,         // no security attributes
        TRUE,         // manual-reset event
        FALSE,         // initial state is signaled
        NULL  // object name
        ); 
	int result=IDNO;
	YesNoThread*  yn=new YesNoThread(handle, &result, question);
	yn->CreateThread();
	WaitForSingleObject(handle, INFINITE);
	CloseHandle(handle);
	return result==IDYES;
}

IglooDialogs::PasswordRootPair IglooDialogs::Login(string cvsroot)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState( ));
    LoginDialog loginDialog(eskimo, CWnd::FromHandle(parentWindow));
	loginDialog.m_CVSROOT=cvsroot.c_str();
    loginDialog.DoModal();
	return PasswordRootPair(string(loginDialog.m_Password),
		string(loginDialog.m_CVSROOT));
}

static string quote(string s)
{
	return string("\"")+s+string("\"");
}

// Returns true if diff results should be shown in dialog
bool IglooDialogs::Diff(FilePath filePath, string& differences)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState( ));
//	PAUSE;
    DiffDialog diffDialog(eskimo, filePath, BaseWindow());
	//CWnd::FromHandle(parentWindow));
    diffDialog.DoModal();
	if (diffDialog.WasCancelled())
	{
		differences="Diff operation cancelled";
		return false;
	}
	UserSettings::DiffType type=diffDialog.GetDiffType();
	Revision revision=diffDialog.GetRevision();
	string revisionNumber=revision.GetRevision();
	if (type==UserSettings::CVS)
	{
		 eskimo->IsDifferent(filePath, revisionNumber, differences);
		 return true;
	}
	else if (type==UserSettings::REGULAR)
	{
		STARTUPINFO si;
		memset(&si,0,sizeof(STARTUPINFO));
		si.cb=sizeof(STARTUPINFO);
		si.dwFlags=STARTF_USESTDHANDLES;
		si.dwFlags|=STARTF_USESHOWWINDOW;
		si.wShowWindow = SW_SHOW; //SW_SHOWMINNOACTIVE;
		PROCESS_INFORMATION process;
		string args;
		FilePath diffPath=eskimo->GetDiffRevision(filePath, revisionNumber);
		if (!diffPath.IsValid())
		{
			Error("Cannot create temporary diff file", "Diff file creation" );
			return false;
		}
		args=quote(filePath.FilePathString())+" "+quote(diffPath.FilePathString());
		differences=string("Differences being shown in ")+diffDialog.GetExe();
		differences += " "+args;
//		args = quote(FilePath(diffDialog.GetExe()).FileName())+" "+args;
		args = quote(diffDialog.GetExe())+" "+args;
		if (!CreateProcess(diffDialog.GetExe().c_str(),
			(char*)args.c_str(),NULL,NULL,FALSE,0,
			NULL,NULL,&si, &process))
		{
			LPVOID lpMsgBuf;
			FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				GetLastError(),
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL 
				);
			// Process any inserts in lpMsgBuf.
			// ...
			// Display the string.
			Error( (LPCTSTR)lpMsgBuf, "Launching diff command" );
			// Free the buffer.
			LocalFree( lpMsgBuf );
		}
		return false;
	}
	else
	{
		FilePath diffPath=eskimo->GetDiffRevision(filePath, revisionNumber);
		if (!diffPath.IsValid())
		{
			Error("Cannot create temporary diff file", "Diff file creation" );
			return false;
		}

		AraxisMerge::Result result=AraxisMerge::FAILURE;
		Revision ancestor=diffDialog.GetAncestor();
		if (ancestor.IsValid())
		{
			string ancestorNumber=ancestor.GetRevision();
			FilePath ancestorPath=eskimo->GetDiffRevision(filePath, ancestorNumber, true);
			if (!ancestorPath.IsValid())
			{
				Error("Cannot create temporary ancestor file", "Ancestor file creation" );
				return false;
			}
			result=AraxisMerge::DoComparison(filePath,
			diffPath, ancestorPath, revision.GetLabel(), ancestor.GetLabel());
		}
		else
		{
			result=AraxisMerge::DoComparison(filePath,
			diffPath, FilePath(), revision.GetLabel(), "");
		}
		if (result==AraxisMerge::FAILURE)
		{
			Error("Could not launch Araxis Merge. Do you have it installed?","Araxis Merge");
		}
		else if (result==AraxisMerge::NO_THREE_WAY)
		{
			Error("Cannot do a three way merge. You do not have Araxis Merge Professional","Araxis Merge");
		}

//		Warning(professional?"Found Professional":"Not Professional", "Prof");
		differences=string("Differences being shown in Araxis Merge");
//			args=string("/title2:\"")+revision.GetLabel()+"\" ";
//			args+=string(filePath.FilePathString())+" "+diffPath.FilePathString();
		return false;
	}
}


void IglooDialogs::Running()
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState( ));
    if (!runningThread)
    {
	    runningHandle = CreateEvent( 
        NULL,         // no security attributes
        TRUE,         // manual-reset event
        FALSE,         // initial state is signaled
        NULL  // object name
        ); 
		
	    runningThread=new RunningThread(runningHandle, parentWindow, ::GetCurrentThreadId());
	    runningThread->CreateThread();
        runningThread->SetThreadPriority(THREAD_PRIORITY_ABOVE_NORMAL);

	    WaitForSingleObject(runningHandle, INFINITE);
        ResetEvent(runningHandle);
    }
//    return new RunningDialog(CWnd::FromHandle(parentWindow));
}

bool IglooDialogs::ShouldStop()
{
    if (runningThread)
    {
		return runningThread->ShouldStop();
	}
	return false;
}


/*
	This returns true if the user stopped the connection
*/
bool IglooDialogs::Stop()
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState( ));
    if (runningThread)
    {
		int enabled=parentWindow?IsWindowEnabled(parentWindow):true;
		if (!enabled) ::EnableWindow(parentWindow, true);
		bool stopped=runningThread->ShouldStop();
	    runningThread->Stop();
        runningThread=0;
	    WaitForSingleObject(runningHandle, INFINITE);
	    CloseHandle(runningHandle);
		if (!enabled)
		{
			::SetActiveWindow(parentWindow);
			::EnableWindow(parentWindow, false);
		}
		return stopped;
    }
	return false;
}

Eskimo::ExtraCommands IglooDialogs::Settings(int files)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState( ));
	SettingsDialog *settingsDialog=0;
	if (eskimo)
	{
		settingsDialog = new SettingsDialog(eskimo, files, CWnd::FromHandle(parentWindow));
	}
	else
	{
		settingsDialog = new SettingsDialog(NULL, 0, CWnd::FromHandle(parentWindow));
	}
	settingsDialog->DoModal();
	Eskimo::ExtraCommands command=settingsDialog->m_Command;
	delete settingsDialog;
	return command;
}

Eskimo::FindModuleResult IglooDialogs::FindCreateModuleAndConnection(string &module,
													   FilePath& localPath,
		string& cvsRoot, bool canChangePath, bool canCreateModule)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState( ));
    CreateModule createModule(eskimo, CWnd::FromHandle(parentWindow));
	createModule.m_LocalPath=localPath.FilePathString();
	createModule.SetFindMode(canChangePath, canCreateModule);
	if (cvsRoot.length()>0)
	{
	}
	else if (getenv("CVSROOT")==NULL)
	{
		if (localPath.IsEmpty())
		{
			cvsRoot="C:\repository";
		}
		else
		{
			FilePath localRootPath=localPath;
			localRootPath.Append("repository");
			cvsRoot=string(localRootPath.FilePathString());
		}
	}
	else
	{
		cvsRoot=getenv("CVSROOT");
	}
    createModule.m_CVSROOT=CString(cvsRoot.c_str());
	createModule.m_ProjectName=CString(module.c_str());;
	createModule.m_ModuleGuess=CString(localPath.GetRepository().c_str());
    createModule.DoModal();
	module=createModule.GetModule();
	localPath=FilePath(createModule.m_LocalPath);
	cvsRoot=createModule.m_CVSROOT;

	return createModule.findResult;// Eskimo::CANCELLED;
}

void IglooDialogs::CreateModuleAndConnection(string projectName, FilePath localPath, string moduleGuess)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState( ));
    CreateModule createModule(eskimo, CWnd::FromHandle(parentWindow));
	createModule.m_LocalPath=localPath.FilePathString();
	string cvsRoot;
	FilePath workspace=localPath.GetWorkspace();
	if (workspace.IsValid())
	{
		cvsRoot=workspace.GetProjectRoot();
	}
	else
	{
		if (getenv("CVSROOT")==NULL)
		{
			FilePath localRootPath=localPath;
			localRootPath.Append("repository");
			cvsRoot=string(localRootPath.FilePathString());
		}
		else
		{
			cvsRoot=getenv("CVSROOT");
		}
	}
    createModule.m_CVSROOT=CString(cvsRoot.c_str());
	createModule.m_ProjectName=CString(projectName.c_str());;
	createModule.m_ModuleGuess=CString(moduleGuess.c_str());;
    createModule.DoModal();
}

int IglooDialogs::MessageBox(string message, string caption, int flags)
{
	if (runningThread)
	{
		return runningThread->MessageBox(message, caption, flags);
	}
	else
	{
		return ::MessageBox(parentWindow, message.c_str(), caption.c_str(), flags);	
	}
}

void IglooDialogs::Error(string message, string caption)
{
	MessageBox(message.c_str(), caption.c_str(), MB_OK | MB_ICONERROR);	
}

void IglooDialogs::Warning(string message, string caption)
{
	MessageBox(message.c_str(), caption.c_str(), MB_OK | MB_ICONWARNING);
}

void IglooDialogs::Info(string message, string caption)
{
	MessageBox(message.c_str(), caption.c_str(), MB_OK | MB_ICONINFORMATION);
}

bool IglooDialogs::Question(string message, string caption)
{
	return MessageBox(message.c_str(), caption.c_str(), MB_YESNO | MB_ICONWARNING)==IDYES;
}

