#ifndef _IglooDialogs_H
#define _IglooDialogs_H

#include "FilePath.h"
#include "Eskimo.h"

class RunningThread;

class IglooDialogs
{
public:
	IglooDialogs();
	void NotifyIDE();
	void SetEskimo(Eskimo* eskimo_);
	void SetParentWindow(HWND window);
	void CreateModuleAndConnection(string projectName, FilePath localPath, string moduleGuess);
	Eskimo::FindModuleResult FindCreateModuleAndConnection(string &module, FilePath& localPath,
		string& cvsRoot, bool canChangePath, bool canCreateModule);
	int MessageBox(string message, string caption, int flags);
	void Info(string message, string caption);
	void Warning(string message, string caption);
	bool Question(string message, string caption);
	void Error(string message, string caption);
	typedef pair<string, string> PasswordRootPair;
	PasswordRootPair Login(string cvsroot);
	bool YesNo(string question);
    void Running();
    bool Stop();
	bool ShouldStop();
	void EnableParent(bool enable);
	bool IsParentEnabled();
	void SetAutoNo(bool value);
	bool Diff(FilePath filePath, string& differences);
    Eskimo::ExtraCommands Settings(int files);
private:
	CWnd* BaseWindow();
	HWND parentWindow;
	Eskimo* eskimo;
    RunningThread* runningThread;
    HANDLE runningHandle;
	bool autoNo;
};

#endif;