// RunningDialog.cpp : implementation file
//

#include "stdafx.h"
#include "igloo.h"
#include "RunningDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// RunningDialog dialog


RunningDialog::RunningDialog(HANDLE handle_, CWnd* pParent /*=NULL*/)
	: CDialog(RunningDialog::IDD, pParent), handle(handle_), messageBox(false),
	shouldStop(false)
{
	::InitializeCriticalSection(&lock);
	//{{AFX_DATA_INIT(RunningDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void RunningDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(RunningDialog)
	DDX_Control(pDX, IDCANCEL, m_CancelButton);
	DDX_Control(pDX, IDC_ANIMATE, m_Animate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(RunningDialog, CDialog)
	//{{AFX_MSG_MAP(RunningDialog)
	ON_WM_COPYDATA()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL RunningDialog::OnInitDialog()
{
	// Create animation control inside static frame.
	// This is necessary to avoid having the animation control
	// "overflow" the rectangle assigned to it when the
	// ACS_CENTER style is removed.
    CDialog::OnInitDialog();
//	CWnd* pFrame = GetDlgItem(IDC_ANIMATE);
//	pFrame->GetClientRect(&m_rectAnimateCtrl);
//	m_Animate.Create(m_dwStyle, m_rectAnimateCtrl, pFrame, IDC_ANIMATE);
//    m_Animate.Open("c:\\gjr\\progress.avi");//    m_Animate.
    m_Animate.Open(IDR_AVI1);
//    m_Animate.Open("c:\\gjr\\test.avi");//    m_Animate.
//    m_Animate.Open("c:\\gjr\\floppy_disk.avi");//    m_Animate.
	m_Animate.Play(0,0xFFFF,-1);
	SetEvent(handle);

	return TRUE;
}	

/////////////////////////////////////////////////////////////////////////////
// RunningDialog message handlers

BOOL RunningDialog::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	// TODO: Add your message handler code here and/or call default
//	EndDialog(0);
	return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}

BOOL RunningDialog::OnCommand(WPARAM wParam, LPARAM lParam) 
{
    int high = wParam>>16;
    int low = wParam & 0xFF;
	// TODO: Add your specialized code here and/or call the base class
	if (high == ACN_START /*&& low == IDC_ANIMATE*//* && lParam== m_Animate.GetSafeHwnd()*/)
    {
//	    SetEvent(handle);
    }
    if (low==16 && lParam==0)
    {
		if (messageBox)
		{
			returnValue=MessageBox(message.c_str(),caption.c_str(), flags);
			SetEvent(handle);
		}
		else
		{
			EndDialog(0);
		}
    }
	return CDialog::OnCommand(wParam, lParam);
}

bool RunningDialog::ShouldStop()
{
	bool result=false;
	::EnterCriticalSection(&lock);
	result=shouldStop;
	
	::LeaveCriticalSection(&lock);
	return result;
}


void RunningDialog::OnCancel() 
{
	// TODO: Add extra cleanup here
	::EnterCriticalSection(&lock);
	shouldStop=true;
	
	::LeaveCriticalSection(&lock);
	m_CancelButton.EnableWindow(false);
	m_CancelButton.SetWindowText("Stopping..");
	
}
