// SettingsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "igloo.h"
#include "SettingsDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SettingsDialog dialog


SettingsDialog::SettingsDialog(Eskimo* eskimo_, int filesSelected_, CWnd* pParent /*=NULL*/)
	: CDialog(SettingsDialog::IDD, pParent), eskimo(eskimo_), 
	filesSelected(filesSelected_), m_Command(Eskimo::NoCommand)
{
	//{{AFX_DATA_INIT(SettingsDialog)
	m_Independent = FALSE;
	m_Offline = FALSE;
	m_Mode = -1;
	m_Concurrent = FALSE;
	//}}AFX_DATA_INIT
    settings.Load();
	if (settings.AutoCommit())
	{
		m_Mode=0;
	}
	else if (settings.WorkIndependently())
	{
		m_Mode=1;
	}
	else if (settings.WorkOffline())
	{
		m_Mode=2;
	}
	m_Concurrent=settings.WarnOnEdit();
}

BOOL SettingsDialog::OnInitDialog()
{
	BOOL result=CDialog::OnInitDialog();
/*	m_ModeBox.AddString("Auto Commit");
	m_ModeBox.AddString("Work Independently");
	m_ModeBox.AddString("Work Offline");*/

	if (filesSelected>0)
	{
		char buffer[100];
		sprintf(buffer, "%d", filesSelected);
		m_ProjectBox.SetWindowText(CString("Project: ")+eskimo->GetProjectName().c_str()+", Files selected "+CString(buffer));
	}
	else if (eskimo!=NULL)
	{
		m_ProjectBox.SetWindowText(CString("Project: ")+eskimo->GetProjectName().c_str()+", No files selected");
	}

	if (filesSelected>0)
	{
	}
	else
	{
		m_WatchRemoveButton.EnableWindow(FALSE);
		m_WatchersButton.EnableWindow(FALSE);
		m_WatchAddButton.EnableWindow(FALSE);
		if (eskimo==NULL)
		{
			m_LogoutButton.EnableWindow(FALSE);
		}
//		m_LoginButton.EnableWindow(FALSE);
		m_EditorsButton.EnableWindow(FALSE);
		m_CommitButtons.EnableWindow(FALSE);
		m_Connect.EnableWindow(FALSE);
	}

	return result;
}



void SettingsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SettingsDialog)
	DDX_Control(pDX, IDC_CONNECT, m_Connect);
	DDX_Control(pDX, IDC_WATCHREMOVE, m_WatchRemoveButton);
	DDX_Control(pDX, IDC_WATCHERS, m_WatchersButton);
	DDX_Control(pDX, IDC_WATCHADD, m_WatchAddButton);
	DDX_Control(pDX, IDC_LOGOUT, m_LogoutButton);
	DDX_Control(pDX, IDC_LOGIN, m_LoginButton);
	DDX_Control(pDX, IDC_EDITORS, m_EditorsButton);
	DDX_Control(pDX, IDC_COMMIT, m_CommitButtons);
	DDX_Control(pDX, IDC_PROJECTBOX, m_ProjectBox);
	DDX_CBIndex(pDX, IDC_MODEBOX, m_Mode);
	DDX_Check(pDX, IDC_CONCURRENT, m_Concurrent);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(SettingsDialog, CDialog)
	//{{AFX_MSG_MAP(SettingsDialog)
	ON_BN_CLICKED(IDC_WATCHERS, OnWatchers)
	ON_BN_CLICKED(IDC_EDITORS, OnEditors)
	ON_BN_CLICKED(IDC_WATCHADD, OnWatchadd)
	ON_BN_CLICKED(IDC_WATCHREMOVE, OnWatchremove)
	ON_BN_CLICKED(IDC_COMMIT, OnCommit)
	ON_BN_CLICKED(IDC_LOGIN, OnLogin)
	ON_BN_CLICKED(IDC_LOGOUT, OnLogout)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SettingsDialog message handlers

void SettingsDialog::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
	settings.SetWorkIndependently(m_Mode==1);
	settings.SetWorkOffline(m_Mode==2);
	settings.SetWarnOnEdit(m_Concurrent==TRUE);
    settings.Save();
}

void SettingsDialog::OnWatchers() 
{
	m_Command=Eskimo::WatchersCommand;
	EndDialog(0);
}

void SettingsDialog::OnEditors() 
{
	m_Command=Eskimo::EditorsCommand;
	EndDialog(0);
}

void SettingsDialog::OnWatchadd() 
{
	m_Command=Eskimo::WatchAddCommand;
	EndDialog(0);
}

void SettingsDialog::OnWatchremove() 
{
	m_Command=Eskimo::WatchRemoveCommand;
	EndDialog(0);
}

void SettingsDialog::OnCommit() 
{
	m_Command=Eskimo::CommitCommand;
	EndDialog(0);
}

void SettingsDialog::OnLogin() 
{
	m_Command=Eskimo::LoginCommand;
	EndDialog(0);
}

void SettingsDialog::OnLogout() 
{
	m_Command=Eskimo::LogoutCommand;
	EndDialog(0);
}

void SettingsDialog::OnConnect() 
{
	m_Command=Eskimo::ConnectCommand;
	EndDialog(0);
}
