#ifndef _UserSettings_h
#define _UserSettings_h

#include <string>
#include "FilePath.h"
#include <map>

using namespace std;

typedef map<string, string> StringMap;

#define STRING_MEMORYS 15

class UserSettings
{
public:
	enum DiffType {CVS=0, REGULAR=1, ARAXIS=2, ARAXIS_PRO=3};
	enum GetSet {GET, SET};
    UserSettings();
    bool WorkIndependently();
    bool WorkOffline();
	bool WarnOnEdit();
    bool AutoCommit();
	bool ReadOnlyFiles();
	bool Mirror();
	FilePath MirrorPath();
    void Load();
    void Save();
    void SetWorkIndependently(bool value);
    void SetWorkOffline(bool value);
	void SetWarnOnEdit(bool value);
	void SetRoot(string root);
	void SetVendor(string root);
	string GetRoot(int index);
	string GetVendor(int index);
	string GetDiffExe();
	void SetDiffExe(string exe);
	void SetDiffType(DiffType type);
	DiffType GetDiffType();

	int GetNumberRoots();
	int GetNumberVendors();
private:
	void LoadSave(GetSet getSet);
    bool workIndependently;
    bool workOffline;
	bool warnOnEdit;
	bool readOnlyFiles;
	bool mirror;
	FilePath mirrorPath;
	string roots[STRING_MEMORYS];
	string vendors[STRING_MEMORYS];
	string regularExe;
	//StringMap diffExes;
	string diffType;
};

#endif // _UserSettings_h